/*
// Created by Tiny on 3/3/2021.
*/

/*!
 * \file GAME.c
 * \brief Game Source File
 * \authors Tin
 * \version 1
 * \date 03/03/2021
 *
 * Explanation.
 *
 */

#include <stdio.h>
#include <SDL2/SDL.h>
#include <SDL2/SDL_image.h>
#include "GAME.h"
#include "prof.h"
#include "personnage.h"
#include "map.h"
#include "DS.h"


SDL_Texture * query_hero(Personnage * hero, SDL_Rect * hero_rect, SDL_Renderer * renderer, SDL_Window * window){

    SDL_Texture * texture_hero;
    init_pers(hero,3,480,28,23,SPEED,"ressource/man.png");

    // load the image data into the graphics hardware's memory
    texture_hero = IMG_LoadTexture(renderer, hero->image_pers);

    if (!texture_hero)
    {
        printf("Cannot create texture for persson: %s\n", SDL_GetError());
        SDL_DestroyRenderer(renderer);
        SDL_DestroyWindow(window);
        SDL_Quit();
        return NULL;
    }

    // get and scale the dimensions of texture
    SDL_QueryTexture(texture_hero, NULL, NULL, &hero_rect->w, &hero_rect->h);
    hero_rect->w =  hero->larg_pers;
    hero_rect->h =  hero->long_pers;

    return texture_hero;
}


SDL_Texture * query_teacher(Prof * teacher, SDL_Rect * teacher_rect, SDL_Renderer * renderer, SDL_Window * window ){

    SDL_Texture * texture_teacher;
    init_prof(teacher,350,380,40,25,SPEED,"ressource/prof.png");

    // load the image data into the graphics hardware's memory
    texture_teacher = IMG_LoadTexture(renderer, teacher->image_prof);

    if (!texture_teacher)
    {
        printf("Cannot create texture for prof: %s\n", SDL_GetError());
        SDL_DestroyRenderer(renderer);
        SDL_DestroyWindow(window);
        SDL_Quit();
        return NULL;
    }

// get and scale the dimensions of texture
    SDL_QueryTexture(texture_teacher, NULL, NULL, &teacher_rect->w, &teacher_rect->h);
    teacher_rect->w = teacher->larg_prof;
    teacher_rect->h = teacher->long_prof;
    teacher_rect->x = teacher->x_prof;
    teacher_rect->y = teacher->y_prof;

    return texture_teacher;
}

SDL_Texture * query_exam(DS * exam, SDL_Rect * exam_rect, SDL_Renderer * renderer, SDL_Window * window){

    fflush(stdin);
    int r = 2 + rand() % 9;       //random [2,10] because bug door 1 impossible => for complete 11->30

    SDL_Texture * texture_exam;
    init_DS(exam,r,"ressource/DS.png");

    // load the image data into the graphics hardware's memory
    texture_exam = IMG_LoadTexture(renderer, exam->image_DS);

    if (!texture_exam)
    {
        printf("error creating texture: %s\n", SDL_GetError());
        SDL_DestroyRenderer(renderer);
        SDL_DestroyWindow(window);
        SDL_Quit();
        return NULL;
    }

    SDL_QueryTexture(texture_exam, NULL, NULL, &exam_rect->w, &exam_rect->h);
    exam_rect->w /= 30;
    exam_rect->h /= 35;
    exam_rect->x=exam->x_DS;
    exam_rect->y=exam->y_DS;

    return texture_exam;
}

SDL_Texture * query_map(MAP * map_game, SDL_Renderer * renderer, SDL_Window * window){
    init_map(map_game,"ressource/colored.bmp","ressource/mapvis.bmp");
    map_game->functional = maptomatrix(map_game);

    //Create a texture for map
    SDL_Texture * texture_map = IMG_LoadTexture(renderer, map_game->visual_path);

    if (!texture_map)
    {
        printf("error creating texture for map: %s\n", SDL_GetError());
        SDL_DestroyRenderer(renderer);
        SDL_DestroyWindow(window);
        SDL_Quit();
        return NULL;
    }

    return texture_map;
}




